// SHPViewerView.h : interface of the CSHPViewerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHPVIEWERVIEW_H__1C9FAEE1_74F4_4A6B_B559_44294D74DCBC__INCLUDED_)
#define AFX_SHPVIEWERVIEW_H__1C9FAEE1_74F4_4A6B_B559_44294D74DCBC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SHP.h"
#include "InfoDLG.h"

class CSHPViewerView : public CView
{
protected: // create from serialization only
	CSHPViewerView();
	DECLARE_DYNCREATE(CSHPViewerView)

// Attributes
public:
	CSHP		m_SHP;

	MBR			m_MBR;

	bool		m_bOpenSHP;

	GPoint		m_geoCenterPoint;	//  ߽ ǥ
	CPoint		m_scrCenterPoint; // ȭ ߽ ǥ
	double		m_lfZoomFactor;	// ZoomIn/out  
	double		m_lfRatio;		// ũ -> Geo ǥ..
	CPoint		m_ptZoomWindowLT, m_ptZoomWindowBR; //»  ϴ ..
	CRect		m_rctScreen;
	
	// ȭ  ..
	enum ManipulMode {None=0, ZoomIn, ZoomOut, ZoomWindow, Panning, CenterMove, Selector, Infotool} m_eManipulationMode;

// Operations
public:
	void			ReMBR(const MBR& _mbr);
	CStatusBar*		GetStatusBar();
	GPoint			DeviceToWorld(const CPoint& _scrPoint);
	CPoint			WorldToDevice(const GPoint& _geoPoint);
	CSHPViewerDoc*	GetDocument();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSHPViewerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSHPViewerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void SetWidth(int _width);
// Generated message map functions
protected:
	//{{AFX_MSG(CSHPViewerView)
	afx_msg void OnZoomIn();
	afx_msg void OnUpdateZoomIn(CCmdUI* pCmdUI);
	afx_msg void OnZoomOut();
	afx_msg void OnUpdateZoomOut(CCmdUI* pCmdUI);
	afx_msg void OnZoomAll();
	afx_msg void OnCenterMove();
	afx_msg void OnUpdateCenterMove(CCmdUI* pCmdUI);
	afx_msg void OnPanning();
	afx_msg void OnUpdatePanning(CCmdUI* pCmdUI);
	afx_msg void OnZoomWindow();
	afx_msg void OnUpdateZoomWindow(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnFileOpen();
	afx_msg void OnFileClose();
	afx_msg void OnVectorSelect();
	afx_msg void OnUpdateVectorSelect(CCmdUI* pCmdUI);
	afx_msg void OnShapeInfo();
	afx_msg void OnUpdateShapeInfo(CCmdUI* pCmdUI);
	afx_msg void OnFileSave();
	afx_msg void OnMenuColorChange();
	afx_msg void OnSize0();
	afx_msg void OnSize1();
	afx_msg void OnSize2();
	afx_msg void OnSize3();
	afx_msg void OnSize4();
	afx_msg void OnSize5();
	afx_msg void OnPsDash();
	afx_msg void OnPsDashdot();
	afx_msg void OnPsDashdotdot();
	afx_msg void OnPsDot();
	afx_msg void OnPsSolid();
	afx_msg void OnMenuBrushcolorChange();
	afx_msg void OnPolygonSolidbrush();
	afx_msg void OnPolygonLine();
	afx_msg void OnShowLabel();
	afx_msg void OnRemoveLabel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SHPViewerView.cpp
inline CSHPViewerDoc* CSHPViewerView::GetDocument()
   { return (CSHPViewerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SHPVIEWERVIEW_H__1C9FAEE1_74F4_4A6B_B559_44294D74DCBC__INCLUDED_)
